
#property copyright ", 2011"
#include <stdlib.mqh>
#include <WinUser32.mqh>

extern int iMagic    = 20110628;
string sComment      = "TopTrendEA";
extern double Lot    = 0.01;
extern int Slippage  = 2;
int i, j, err;
int Length        = 20;
int Deviation     = 2;
double MoneyRisk  = 1.0;
int Signal        = 1;
int Line          = 1;
int Nbars         = 1000;

int init()
  {
   return(0);
  }

int deinit()
  {
   return(0);
  }

int start()
   {
   bool TSell         = false;
   bool TBuy          = false;
   int limit, i;

   if (IsNewBar())
      {
      if (OpenedTrade(iMagic))
         {
         int total = OrdersTotal();
         if (total > 0)
            {
            for(int cnt=0;cnt<total;cnt++)
               {
               if(OrderSelect(cnt,SELECT_BY_POS) && OrderMagicNumber() == iMagic)
                  {
                  if(OrderType() == OP_BUY)
                     {
                     if (iCustom(NULL, 0, "TOPTREND (2)", Length, Deviation, MoneyRisk, Signal, Line, Nbars, 3, 1) != -1)
                        {
                        OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Bid, Digits), Slippage, GreenYellow);
                        err = GetLastError();
                        Print("Error: ", err, " ", ErrorDescription(err));
                        }
                     }
                  if(OrderType() == OP_SELL)
                     {
                     if (iCustom(NULL, 0, "TOPTREND (2)", Length, Deviation, MoneyRisk, Signal, Line, Nbars, 2, 1) != -1)
                        {
                        OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Bid, Digits), Slippage, GreenYellow);
                        err = GetLastError();
                        Print("Error: ", err, " ", ErrorDescription(err));
                        }
                     }
                  }
               }
            }
         }
         
      if (!OpenedTrade(iMagic))
         {
         if (iCustom(NULL, 0, "TOPTREND (2)", Length, Deviation, MoneyRisk, Signal, Line, Nbars, 3, 1) != -1)
            {
            TSell = true;
            }
         if (iCustom(NULL, 0, "TOPTREND (2)", Length, Deviation, MoneyRisk, Signal, Line, Nbars, 2, 1) != -1)
            {
            TBuy = true;
            }
         if (TSell)
            {
            OrderSend(Symbol(), OP_SELL, Lot, NormalizeDouble(Bid, Digits), Slippage, 0, 0, sComment, iMagic, CLR_NONE, Green);
            err = GetLastError();
            Print("Error: ", err, " ", ErrorDescription(err));
            }
         if (TBuy)
            {
            OrderSend(Symbol(), OP_BUY, Lot, NormalizeDouble(Ask, Digits), Slippage, 0, 0, sComment, iMagic, CLR_NONE, Green);
            err = GetLastError();
            Print("Error: ", err, " ", ErrorDescription(err));
            }
         }
      }

      Comment(BrokerTime(), "\nrev. 20110628",
              "\n",
              "\nUpBuff:   ", iCustom(NULL, 0, "TOPTREND (2)", Length, Deviation, MoneyRisk, Signal, Line, Nbars, 0, 0),
              "\nDnBuff:   ", iCustom(NULL, 0, "TOPTREND (2)", Length, Deviation, MoneyRisk, Signal, Line, Nbars, 1, 0),
              "\n",
              "\nUpSignal: ", iCustom(NULL, 0, "TOPTREND (2)", Length, Deviation, MoneyRisk, Signal, Line, Nbars, 2, 0),
              "\nDnSignal: ", iCustom(NULL, 0, "TOPTREND (2)", Length, Deviation, MoneyRisk, Signal, Line, Nbars, 3, 0),
              "\nUpSignal: ", iCustom(NULL, 0, "TOPTREND (2)", Length, Deviation, MoneyRisk, Signal, Line, Nbars, 2, 1),
              "\nDnSignal: ", iCustom(NULL, 0, "TOPTREND (2)", Length, Deviation, MoneyRisk, Signal, Line, Nbars, 3, 1),
              "\n",
              "\nUpLine:   ", iCustom(NULL, 0, "TOPTREND (2)", Length, Deviation, MoneyRisk, Signal, Line, Nbars, 4, 0),
              "\nDnLine:   ", iCustom(NULL, 0, "TOPTREND (2)", Length, Deviation, MoneyRisk, Signal, Line, Nbars, 5, 0)
              );
           
   return(0);
   }

bool OpenedTrade(int iMagic)
   {
   int total = OrdersTotal();
   if (total > 0)
      {
      for(int cnt=0;cnt<total;cnt++)
         {
         if(OrderSelect(cnt,SELECT_BY_POS))
            {
            if(OrderSymbol()==Symbol() && OrderMagicNumber() == iMagic)
               {
               return (true);
               }
            }
         }
      }
   }

string BrokerTime()
   {
   string strMinutePad, strSecondsPad;
   
   if(TimeMinute(TimeCurrent()) >= 0 && TimeMinute(TimeCurrent()) <= 9)
      strMinutePad = "0";
   else
      strMinutePad = "";
      
   if(TimeSeconds(TimeCurrent()) >= 0 && TimeSeconds(TimeCurrent()) <= 9)
      strSecondsPad = "0";
   else
      strSecondsPad = "";
      
   return(StringConcatenate("Broker\'s Time: ", TimeHour(TimeCurrent()), ":", strMinutePad, TimeMinute(TimeCurrent()), ":", strSecondsPad, TimeSeconds(TimeCurrent())));
   }

bool IsNewBar()
   {
   static datetime lastbar;
   datetime curbar = Time[0];
   if (lastbar != curbar)
      {
      lastbar = curbar;
      return(true);
      }
   else
      {
      return(false);
      }
   }


